------------------------------------------------------------------------------------------
-- UI file
-- Written by Homeopatix
-- 7 january 2021
------------------------------------------------------------------------------------------
-- create the window
------------------------------------------------------------------------------------------
centerWindow = {};
centerLabel = {};
centerQS = {};

function GenerateWindow()

		local horizontalPosition = 20 ;
		local verticalPosition = 40;
		local nbrSlot = 0;
		local windowWidth = (settings["nbrSlots"]["nbr"] * 42) + 38;
		local windowHeight = 0;

		windowHeight = (settings["nbrLine"]["nbr"] * 42) + 60;
		local totalSlots = tonumber(settings["nbrSlots"]["nbr"]) * tonumber(settings["nbrLine"]["nbr"]);

		if(settings["borderShow"]["value"] == true)then
			PotionsWindow=Turbine.UI.Lotro.GoldWindow(); 
		else
			PotionsWindow=Turbine.UI.Extensions.SimpleWindow(); 
		end 
		PotionsWindow:SetSize(windowWidth, windowHeight); 
		PotionsWindow:SetText(Strings.PluginName); 

		PotionsWindow.Message=Turbine.UI.Label(); 
		PotionsWindow.Message:SetParent(PotionsWindow); 
		PotionsWindow.Message:SetSize(150,10); 
		PotionsWindow.Message:SetPosition(windowWidth/2 - 75, windowHeight - 20 ); 
		PotionsWindow.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
		if(settings["borderShow"]["value"] == true)then
			PotionsWindow.Message:SetText(Strings.PluginText); 
		else
			PotionsWindow.Message:SetText(""); 
		end 
		

		PotionsWindow:SetZOrder(0);
		PotionsWindow:SetWantsKeyEvents(true);
		PotionsWindow:SetWantsUpdates(true);
		if(settings["alwaysShow"]["value"] == true)then
			PotionsWindow:SetVisible(true);
		end

		PotionsWindow:SetPosition(settings["windowPosition"]["xPos"], settings["windowPosition"]["yPos"]);

		------------------------------------------------------------------------------------------
		-- center window --
		------------------------------------------------------------------------------------------

		for i=1, totalSlots do
			if(nbrSlot == tonumber(settings["nbrSlots"]["nbr"]))then
				verticalPosition = verticalPosition + 42;
				nbrSlot = 0;
				horizontalPosition = 20;
			end
			
			centerWindow[i] = Turbine.UI.Extensions.SimpleWindow();
			centerWindow[i]:SetSize( 40 , 40 );
			centerWindow[i]:SetParent( PotionsWindow );
			centerWindow[i]:SetPosition( horizontalPosition , verticalPosition);
			centerWindow[i]:SetVisible( true );
			if(i == 1)then
				centerWindow[i]:SetBackColor( Turbine.UI.Color(.3, 1, 0.9, 0.5) ); -- jaune
			elseif(i == 2)then
				centerWindow[i]:SetBackColor( Turbine.UI.Color( .3, .5, 1, 1 ) ); -- blue
			elseif(i == 3)then
				centerWindow[i]:SetBackColor( Turbine.UI.Color( .3, .9, .1, 0 ) ); -- red
			else
				centerWindow[i]:SetBackColor( Turbine.UI.Color( .3, .5, .7, .5) ); -- green
			end
			
			centerLabel = Turbine.UI.Label();
			centerLabel:SetParent(centerWindow[i]);
			centerLabel:SetPosition( 0, 0 );
			centerLabel:SetSize( 40, 40  );
			centerLabel:SetText( "" );
			centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
			centerLabel:SetZOrder(-1);
			centerLabel:SetMouseVisible(false);

			centerQS[i] = Turbine.UI.Lotro.Quickslot();
			centerQS[i]:SetParent( centerWindow[i] );
			centerQS[i]:SetPosition( 1, 1 );
			centerQS[i]:SetSize( 36, 36 );
			centerQS[i]:SetUseOnRightClick(false);

			nbrSlot = nbrSlot + 1;
			horizontalPosition = horizontalPosition + 42;
		end
------------------------------------------------------------------------------------------
-- setting the datas	
------------------------------------------------------------------------------------------
	SettingTheShortCuts();
	DragAndDrop();
	DeleteShortCutes();
	MouseClickHandler();
	EscapeKeyPressed();
	ClosingTheWindow();
end
------------------------------------------------------------------------------------------
-- setting the shortcuts	
------------------------------------------------------------------------------------------
function SettingTheShortCuts()
		local totalSlots = tonumber(settings["nbrSlots"]["nbr"]) * tonumber(settings["nbrLine"]["nbr"]);

		for i=1, totalSlots do
			if(settings["shortcuts"]["Data" .. i] ~= "") then
				centerQS[i]:SetShortcut( Turbine.UI.Lotro.Shortcut( settings["shortcuts"]["Type" .. i], settings["shortcuts"]["Data" .. i] ) );
			end
		end
end
------------------------------------------------------------------------------------------
-- setting the shortcuts for drag and drop	
------------------------------------------------------------------------------------------
function DragAndDrop()
	local totalSlots = tonumber(settings["nbrSlots"]["nbr"]) * tonumber(settings["nbrLine"]["nbr"]);

	for i=1, totalSlots do
		centerQS[i].DragDrop = function(sender, args)
			local tmp = Turbine.UI.Lotro.Quickslot();

			tmp = centerQS[i]:GetShortcut();
			tmp = tmp:GetData();

			settings["shortcuts"]["Data" .. i] = tmp;

			tmp2 = centerQS[i]:GetShortcut();
			tmp2 = tmp2:GetType();

			settings["shortcuts"]["Type" .. i] = tmp2;

			SaveSettings();
		end
	end
end
------------------------------------------------------------------------------------------
-- delete the shortcut with mouse wheel
------------------------------------------------------------------------------------------
function DeleteShortCutes()
	local totalSlots = tonumber(settings["nbrSlots"]["nbr"]) * tonumber(settings["nbrLine"]["nbr"]);

	for i=1, totalSlots do
		centerQS[i].MouseWheel = function(sender, args)
			if(settings.isLocked == false)then
				settings["shortcuts"]["Data" .. i] = ""; 
				settings["shortcuts"]["Type" .. i] = "";
				centerQS[i]:SetShortcut(Turbine.UI.Lotro.Shortcut());
				SaveSettings();
			end
		end
	end
end
------------------------------------------------------------------------------------------
-- MousCLick Handler
------------------------------------------------------------------------------------------
function MouseClickHandler()
	local totalSlots = tonumber(settings["nbrSlots"]["nbr"]) * tonumber(settings["nbrLine"]["nbr"]);

	for i=1, totalSlots do
		centerQS[i].MouseClick = function(sender, args)
			if(settings["alwaysShow"]["value"] == false) then
				settings["isWindowVisible"]["isWindowVisible"] = false;
				PotionsWindow:SetVisible(false);
			end
			SaveSettings();
		end
	end
end
------------------------------------------------------------------------------------------
-- MousCLick Handler
------------------------------------------------------------------------------------------
function MouseClickHandlerForRandomMount()
	centerQSRandom.MouseClick = function(sender, args)
		PotionsWindow:SetVisible(false);
		settings["isWindowVisible"]["isWindowVisible"] = false;
		SaveSettings();
	end
end
------------------------------------------------------------------------------------------
-- Closing window handler
------------------------------------------------------------------------------------------
function ClosingTheWindow()
	function PotionsWindow:Closing(sender, args)
		settings["isWindowVisible"]["isWindowVisible"] = false;
		SaveSettings();
	end
end
------------------------------------------------------------------------------------------
-- updating the window
------------------------------------------------------------------------------------------
function UpdateWindow()
	GenerateWindow();
end